FORMAT	PE GUI 4.0

INCLUDE 'win32wxp.inc'
ENTRY	start


SECTION '.text' CODE EXECUTABLE READABLE
start:
	xor	ebx,ebx

	sub	esp,sizeof.SYSTEM_INFO
	invoke	GetSystemInfo,esp
	mov	edi,[esp+SYSTEM_INFO.dwPageSize]
	add	esp,sizeof.SYSTEM_INFO

	sub	esp,sizeof.MEMORYSTATUS
	mov	[esp+MEMORYSTATUS.dwiLength],sizeof.MEMORYSTATUS

	invoke	GlobalMemoryStatus,esp

	mov	edx,[esp+MEMORYSTATUS.dwAvailPhys]
	mov	esi,[esp+MEMORYSTATUS.dwAvailVirtual]
	add	esp,sizeof.MEMORYSTATUS

	neg	edi
	and	edx,edi
	and	esi,edi

	cmp	esi,edx
	cmova	esi,edx
@@:
	invoke	VirtualAlloc,ebx,esi,MEM_RESERVE,PAGE_READWRITE
	sub	esi,1024*1024
	test	eax,eax
	jz	@B

	add	esi,1024*1024
	mov	[_size],esi
	invoke	VirtualFree,eax,ebx,MEM_RELEASE

	invoke	GetCurrentThread
	invoke	SetThreadAffinityMask,eax,1

	invoke	QueryPerformanceFrequency,freq

	xor	esi,esi
@@:
	invoke	GetCurrentProcess
	invoke	SetPriorityClass,eax,REALTIME_PRIORITY_CLASS
	invoke	GetCurrentThread
	invoke	SetThreadPriority,eax,THREAD_PRIORITY_TIME_CRITICAL

	invoke	VirtualAlloc,esi,[_size],MEM_COMMIT OR MEM_RESERVE,PAGE_READWRITE; OR PAGE_NOCACHE
	test	eax,eax
	jz	.fail
	mov	esi,eax
	mov	edi,eax

	xor	eax,eax
	mov	ecx,[_size]
	shr	ecx,2
	rep	stosd		; spoils commited pages (real allocation)

	mov	edi,esi
;invoke  Sleep,400
	invoke	QueryPerformanceCounter,strtTime
;-----------------------------------------------
;        xor     eax,eax
;        not     eax
;        mov     ecx,[_size]
;        shr     ecx,2
;        rep     stosd
;-----------------------------------------------
;        mov     ecx,[_size]
;        sub     edi,4
;        and     ecx,-4
;        jz      .next
;        xor     eax,eax
;        not     eax
;.loop:
;        movnti  [edi+ecx],eax
;        sub     ecx,4
;        jnz     .loop
;-----------------------------------------------
	mov	ecx,[_size]
	xor	eax,eax
	and	ecx,-16
	jz	.next
	pcmpeqd xmm0,xmm0
.loop:
	movntdq [edi+eax],xmm0
	add	eax,16
	cmp	eax,ecx
	jnz	.loop
;-----------------------------------------------
;        mov     ecx,[_size]
;        sub     edi,16
;        pcmpeqd xmm0,xmm0
;        and     ecx,-16
;        jz      .next
;.loop:
;        movntdq [edi+ecx],xmm0
;        sub     ecx,16
;        jnz     .loop
;-----------------------------------------------
;        mov     ecx,[_size]
;        pcmpeqd xmm0,xmm0
;        jecxz   .next
;        add     ecx,edi
;.loop:
;        movntdq [edi],xmm0
;        add     edi,16
;        cmp     edi,ecx
;        jne     .loop
;-----------------------------------------------
;        pcmpeqd mm0,mm0
;        mov     ecx,[_size]
;        sub     edi,8
;        and     ecx,-8
;        jz      .next
;.loop:
;        movntq  [edi+ecx],mm0
;        sub     ecx,8
;        jnz     .loop
;-----------------------------------------------
;        invoke  RtlFillMemory,edi,[_size],-1
;-----------------------------------------------
.next:
	invoke	QueryPerformanceCounter,endTime

	fninit
	push	[_size]

	fild	[endTime]
	fild	[strtTime]
	fsubp
	fld	st0
	fild	[freq]
	fdivp
	fist	[sec]
	fild	DWORD [esp]
	fdivrp
	fistp	[bps]
	fild	DWORD [esp]
	fdivrp
	fistp	[bpt]

	movd	mm0,[esp]
	psrlq	mm0,20
	movd	edi,mm0

	pop	eax

	movq	mm0,[bps]
	psrlq	mm0,20
	movd	[Mbps],mm0
	emms

	invoke	GetCurrentThread
	invoke	SetThreadPriority,eax,THREAD_PRIORITY_NORMAL
	invoke	GetCurrentProcess
	invoke	SetPriorityClass,eax,NORMAL_PRIORITY_CLASS

	cinvoke wsprintf,txt,_txt,edi,[sec],[bpt],[Mbps]

	invoke	MessageBox,ebx,txt,_capt,MB_OKCANCEL
	cmp	eax,IDCANCEL
	je	@F

	invoke	VirtualFree,esi,ebx,MEM_RELEASE
	test	eax,eax
	jnz	@B
@@:
	invoke	VirtualFree,esi,ebx,MEM_RELEASE
.fail:
	invoke	ExitProcess,ebx

SECTION '.idata' DATA READABLE WRITABLE IMPORT
library kernel32,'KERNEL32.DLL',\
	user32,'USER32.DLL'

INCLUDE 'api\kernel32.inc'
INCLUDE 'api\user32.inc'


SECTION '.rdata' DATA READABLE
_capt	DU	'Results asmfan',0
_txt	DU	'Tested Max Available [%lu] MB',0Dh,0Ah,0Dh,0Ah
	DU	'[%lu] sec; [%lu] B/Tick; [%lu] MB/s',0Dh,0Ah,0Dh,0Ah
	DU	'Continue measurement?',0


SECTION '.bss' READABLE WRITEABLE
freq	DQ	?
strtTime	DQ	?
endTime DQ	?
bps	DQ	?
_size	DD	?
Mbps	DD	?
sec	DD	?
bpt	DD	?
txt	RW	MAX_PATH